// fpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "fp.h"
#include "fpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CfpDlg dialog


const ULONGLONG SignMask     = 0x8000000000000000;
const ULONGLONG ExponentMask = 0x7FF0000000000000;
const ULONGLONG MantissaMask = 0x000FFFFFFFFFFFFF;

CfpDlg::CfpDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CfpDlg::IDD, pParent)
   {
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    initialized = FALSE;
   }

void CfpDlg::DoDataExchange(CDataExchange* pDX)
   {
    CDialog::DoDataExchange(pDX);

    DDX_Control(pDX, IDC_HEX_MANTISSA, c_HexMantissa);
    DDX_Control(pDX, IDC_NUMBER, c_Number);
    DDX_Control(pDX, IDC_FORMAT_N, c_FormatN);
    DDX_Control(pDX, IDC_FORMAT_1, c_Format1);
    DDX_Control(pDX, IDC_FORMAT_2, c_Format2);
    DDX_Control(pDX, IDC_FORMAT_3, c_Format3);
    DDX_Control(pDX, IDC_BINARY_EXPONENT, c_BinaryExponent);
    DDX_Control(pDX, IDC_SPIN_BINARY_EXPONENT, c_SpinBinaryExponent);
    DDX_Control(pDX, IDC_EXCESS1024_EXPONENT, c_Excess1024Exponent);
    DDX_Control(pDX, IDC_SPIN_EXCESS_1024_EXPONENT, c_SpinExcess1024Exponent);
    DDX_Control(pDX, IDC_NUMBER1, c_Number1);
    DDX_Control(pDX, IDC_NUMBER2, c_Number2);
    DDX_Control(pDX, IDC_NUMBER3, c_Number3);

    DDX_Control(pDX, IDC_FORMAT, c_Format);

    DDX_Control(pDX, IDC_SET_FORMAT_N, c_SetFormatN);
    DDX_Control(pDX, IDC_SET_FORMAT_1, c_SetFormat1);
    DDX_Control(pDX, IDC_SET_FORMAT_2, c_SetFormat2);
    DDX_Control(pDX, IDC_SET_FORMAT_3, c_SetFormat3);

    // flags
    DDX_Control(pDX, IDC_FORMAT_MINUS, c_FormatMinus);
    DDX_Control(pDX, IDC_FORMAT_PLUS, c_FormatPlus);
    DDX_Control(pDX, IDC_FORMAT_ZERO, c_FormatZero);
    DDX_Control(pDX, IDC_FORMAT_HASH, c_FormatHash);
    DDX_Control(pDX, IDC_FORMAT_BLANK, c_FormatBlank);

    // width
    DDX_Control(pDX, IDC_WIDTH_NONE, c_WidthNone);
    DDX_Control(pDX, IDC_USE_WIDTH, c_UseWidth);
    DDX_Control(pDX, IDC_WIDTH, c_Width);
    DDX_Control(pDX, IDC_SPIN_WIDTH, c_SpinWidth);

    // precision
    DDX_Control(pDX, IDC_PRECISION_NONE, c_PrecisionNone);
    DDX_Control(pDX, IDC_USE_PRECISION, c_UsePrecision);
    DDX_Control(pDX, IDC_PRECISION, c_Precision);
    DDX_Control(pDX, IDC_SPIN_PRECISION, c_SpinPrecision);
    DDX_Control(pDX, IDC_DOT, c_Dot);

    // type
    DDX_Control(pDX, IDC_TYPE_LOWER_E, c_Type_e);
    DDX_Control(pDX, IDC_TYPE_UPPER_E, c_Type_E);
    DDX_Control(pDX, IDC_TYPE_F, c_Type_f);
    DDX_Control(pDX, IDC_TYPE_LOWER_G, c_Type_g);
    DDX_Control(pDX, IDC_TYPE_UPPER_G, c_Type_G);

    // bits <=> values
    DDX_Control(pDX, IDC_TO_1, c_NumberTo1);
    DDX_Control(pDX, IDC_TO_2, c_NumberTo2);
    DDX_Control(pDX, IDC_TO_3, c_NumberTo3);

    DDX_Control(pDX, IDC_FROM_1, c_1ToNumber);
    DDX_Control(pDX, IDC_FROM_2, c_2ToNumber);
    DDX_Control(pDX, IDC_FROM_3, c_3ToNumber);

    DDX_Control(pDX, IDC_SHOW_SPACES, c_ShowSpaces);

    DDX_Control(pDX, IDC_1_TO_2, c_1To2);
    DDX_Control(pDX, IDC_1_TO_3, c_1To3);
    DDX_Control(pDX, IDC_2_TO_1, c_2To1);
    DDX_Control(pDX, IDC_2_TO_3, c_2To3);
    DDX_Control(pDX, IDC_3_TO_1, c_3To1);
    DDX_Control(pDX, IDC_3_TO_2, c_3To2);

   }

BEGIN_MESSAGE_MAP(CfpDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        ON_CONTROL_RANGE(BN_CLICKED, IDC_00, IDC_63, OnBitChanged)
        ON_BN_CLICKED(IDC_SET_ALL_EXPONENT, OnSetAllExponent)
        ON_BN_CLICKED(IDC_CLEAR_ALL_EXPONENT, OnClearAllExponent)
        ON_BN_CLICKED(IDC_ZERO_EXPONENT, OnZeroExponent)
        ON_BN_CLICKED(IDC_SET_ALL_MANTISSA, OnSetAllMantissa)
        ON_BN_CLICKED(IDC_CLEAR_ALL_MANTISSA, OnClearAllMantissa)
        ON_BN_CLICKED(IDC_PLUS_INFINITY, OnBnClickedInfPlus)
        ON_BN_CLICKED(IDC_MINUS_INFINITY, OnBnClickedInfMinus)
        ON_BN_CLICKED(IDC_NAN_PLUS, OnBnClickedNaNPlus)
        ON_BN_CLICKED(IDC_NAN_MINUS, OnBnClickedNaNMinus)
        ON_BN_CLICKED(IDC_TYPE_UPPER_E, OnUpdateRequest)
        ON_BN_CLICKED(IDC_TYPE_LOWER_E, OnUpdateRequest)
        ON_BN_CLICKED(IDC_TYPE_UPPER_G, OnUpdateRequest)
        ON_BN_CLICKED(IDC_TYPE_LOWER_G, OnUpdateRequest)
        ON_BN_CLICKED(IDC_TYPE_F, OnUpdateRequest)
        ON_BN_CLICKED(IDC_PRECISION_NONE, OnUpdateRequest)
        ON_BN_CLICKED(IDC_USE_PRECISION, OnUpdateRequest)
        ON_BN_CLICKED(IDC_WIDTH_NONE, OnUpdateRequest)
        ON_BN_CLICKED(IDC_USE_WIDTH, OnUpdateRequest)
        ON_BN_CLICKED(IDC_FORMAT_MINUS, OnUpdateRequest)
        ON_BN_CLICKED(IDC_FORMAT_PLUS, OnUpdateRequest)
        ON_BN_CLICKED(IDC_FORMAT_ZERO, OnUpdateRequest)
        ON_BN_CLICKED(IDC_FORMAT_HASH, OnUpdateRequest)
        ON_EN_CHANGE(IDC_WIDTH, OnUpdateRequest)
        ON_EN_CHANGE(IDC_NUMBER, OnChangeNumber)
        ON_EN_CHANGE(IDC_PRECISION, OnUpdateRequest)
        ON_EN_CHANGE(IDC_BINARY_EXPONENT, OnChangeBinaryExponent)
        ON_EN_CHANGE(IDC_NUMBER1,OnChangeNumber1)
        ON_EN_CHANGE(IDC_NUMBER2,OnChangeNumber2)
        ON_EN_CHANGE(IDC_NUMBER3,OnChangeNumber3)
        ON_EN_CHANGE(IDC_EXCESS1024_EXPONENT, OnChangeExcess1024Exponent)
        ON_EN_CHANGE(IDC_HEX_MANTISSA, OnChangeHexMantissa)
        ON_BN_CLICKED(IDC_SET_FORMAT_N, OnBnClickedSetFormatNumberN)
        ON_BN_CLICKED(IDC_SET_FORMAT_1, OnBnClickedSetFormat1)
        ON_BN_CLICKED(IDC_SET_FORMAT_2, OnBnClickedSetFormat2)
        ON_BN_CLICKED(IDC_SET_FORMAT_3, OnBnClickedSetFormat3)
        ON_BN_CLICKED(IDC_SHOW_SPACES, OnBnClickedShowSpaces)
        ON_BN_CLICKED(IDC_1_TO_2, OnBnClicked1To2)
        ON_BN_CLICKED(IDC_1_TO_3, OnBnClicked1To3)
        ON_BN_CLICKED(IDC_2_TO_1, OnBnClicked2To1)
        ON_BN_CLICKED(IDC_2_TO_3, OnBnClicked2To3)
        ON_BN_CLICKED(IDC_3_TO_1, OnBnClicked3To1)
        ON_BN_CLICKED(IDC_3_TO_2, OnBnClicked3To2)
        ON_BN_CLICKED(IDC_TO_1, OnBnClickedNumberTo1)
        ON_BN_CLICKED(IDC_TO_2, OnBnClickedNumberTo2)
        ON_BN_CLICKED(IDC_TO_3, OnBnClickedNumberTo3)
        ON_BN_CLICKED(IDC_ADD, OnBnClickedAdd)
        ON_BN_CLICKED(IDC_SUBTRACT, OnBnClickedSubtract)
        ON_BN_CLICKED(IDC_MULTIPLY, OnBnClickedMultiply)
        ON_BN_CLICKED(IDC_DIVIDE, OnBnClickedDivide)
        ON_BN_CLICKED(IDC_FROM_1, OnBnClickedFrom1)
        ON_BN_CLICKED(IDC_FROM_2, OnBnClickedFrom2)
        ON_BN_CLICKED(IDC_FROM_3, OnBnClickedFrom3)
        ON_WM_CLOSE()
END_MESSAGE_MAP()


// CfpDlg message handlers

BOOL CfpDlg::OnInitDialog()
{
        CDialog::OnInitDialog();

        // Add "About..." menu item to system menu.

        // IDM_ABOUTBOX must be in the system command range.
        ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
        ASSERT(IDM_ABOUTBOX < 0xF000);

        CMenu* pSysMenu = GetSystemMenu(FALSE);
        if (pSysMenu != NULL)
        {
                CString strAboutMenu;
                strAboutMenu.LoadString(IDS_ABOUTBOX);
                if (!strAboutMenu.IsEmpty())
                {
                        pSysMenu->AppendMenu(MF_SEPARATOR);
                        pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
                }
        }

        // Set the icon for this dialog.  The framework does this automatically
        //  when the application's main window is not a dialog
        SetIcon(m_hIcon, TRUE);                 // Set big icon
        SetIcon(m_hIcon, FALSE);                // Set small icon

        // TODO: Add extra initialization here
        
        c_SpinPrecision.SetRange(1,24);
        c_SpinPrecision.SetPos(1);
        c_SpinWidth.SetRange(1,24);
        c_SpinWidth.SetPos(1);

        c_SpinBinaryExponent.SetRange(0, 2047);
        c_SpinBinaryExponent.SetPos(1023);

        c_SpinExcess1024Exponent.SetRange(-1024, 1023);
        c_SpinExcess1024Exponent.SetPos(0);

        CheckRadioButton(IDC_WIDTH_NONE, IDC_USE_WIDTH, IDC_WIDTH_NONE);
        CheckRadioButton(IDC_PRECISION_NONE, IDC_USE_PRECISION, IDC_PRECISION_NONE);
        CheckRadioButton(IDC_TYPE_LOWER_E, IDC_TYPE_UPPER_G, IDC_TYPE_F);

        c_FormatN.SetWindowText(_T("%f"));
        c_SetFormatN.SetDirection(DrawArrow::ARROW_N);

        c_Format1.SetWindowText(_T("%f"));
        c_SetFormat1.SetDirection(DrawArrow::ARROW_N);

        c_Format2.SetWindowText(_T("%f"));
        c_SetFormat2.SetDirection(DrawArrow::ARROW_N);

        c_Format3.SetWindowText(_T("%f"));
        c_SetFormat3.SetDirection(DrawArrow::ARROW_N);

        c_NumberTo1.SetDirection(DrawArrow::ARROW_S);
        c_NumberTo2.SetDirection(DrawArrow::ARROW_S);
        c_NumberTo3.SetDirection(DrawArrow::ARROW_S);
        c_1ToNumber.SetDirection(DrawArrow::ARROW_N);
        c_2ToNumber.SetDirection(DrawArrow::ARROW_N);
        c_3ToNumber.SetDirection(DrawArrow::ARROW_N);

        c_1To2.SetDirection(DrawArrow::ARROW_E);
        c_1To3.SetDirection(DrawArrow::ARROW_E);
        c_2To3.SetDirection(DrawArrow::ARROW_E);
        c_2To1.SetDirection(DrawArrow::ARROW_W);
        c_3To1.SetDirection(DrawArrow::ARROW_W);
        c_3To2.SetDirection(DrawArrow::ARROW_W);
        initialized = TRUE;
        updateControls();

        return TRUE;  // return TRUE  unless you set the focus to a control
}

void CfpDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CfpDlg::OnPaint() 
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CfpDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}

/****************************************************************************
*                                CfpDlg::OnOK
* Result: void
*       
* Effect: 
*       Does nothing; this prevents closing the dialog with <enter>
****************************************************************************/

void CfpDlg::OnOK()
    {
    }

/****************************************************************************
*                              CfpDlg::OnCancel
* Result: void
*       
* Effect: 
*       Does nothing; this prevents closing the app with <esc>
****************************************************************************/

void CfpDlg::OnCancel()
    {
    }

/****************************************************************************
*                               CfpDlg::OnClose
* Result: void
*       
* Effect: 
*       Closes the app
****************************************************************************/

void CfpDlg::OnClose()
    {
     CDialog::OnOK();
    }

/****************************************************************************
*                            CfpDlg::OnBitChanged
* Inputs:
*       UINT id: ID of bit that changed
* Result: void
*       
* Effect: 
*       Converts the binary value to a floating point word
****************************************************************************/

void CfpDlg::OnBitChanged(UINT id)
    {
     BitsToFP();
     updateControls();
    } // CfpDlg::OnBitChanged

/****************************************************************************
*                           CfpDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the state of the controls
****************************************************************************/

void CfpDlg::updateControls()
    {
     if(!initialized)
        return;
     
     CString format = _T("%");

     if(c_FormatMinus.GetCheck() == BST_CHECKED)
        format += _T("-");
     if(c_FormatPlus.GetCheck() == BST_CHECKED)
        format += _T("+");
     if(c_FormatZero.GetCheck() == BST_CHECKED)
        format += _T("0");
     if(c_FormatHash.GetCheck() == BST_CHECKED)
        format += _T("#");
     if(c_FormatBlank.GetCheck() == BST_CHECKED)
        format += _T(" ");
     
     if(c_UseWidth.GetCheck() == BST_CHECKED)
        { /* has width */
         int n = c_SpinWidth.GetPos32();
         CString s;
         s.Format(_T("%d"), n);
         format += s;
        } /* has width */

     if(c_UsePrecision.GetCheck() == BST_CHECKED)
        { /* has precision */
         c_Dot.ShowWindow(SW_SHOW);
         int n = c_SpinPrecision.GetPos32();
         CString s;
         s.Format(_T(".%d"), n);
         format += s;
        } /* has precision */
     else
        { /* no precision */
         c_Dot.ShowWindow(SW_HIDE);
        } /* no precision */

     if(c_Type_e.GetCheck() == BST_CHECKED)
        format += _T("e");
     if(c_Type_E.GetCheck() == BST_CHECKED)
              format += _T("E");
     if(c_Type_f.GetCheck() == BST_CHECKED)
        format += _T("f");
     if(c_Type_g.GetCheck() == BST_CHECKED)
        format += _T("g");
     if(c_Type_G.GetCheck() == BST_CHECKED)
        format += _T("G");

     c_Format.SetWindowText(format);
     
     c_Precision.EnableWindow(c_UsePrecision.GetCheck() == BST_CHECKED);
     c_SpinPrecision.EnableWindow(c_UsePrecision.GetCheck() == BST_CHECKED);

     c_Width.EnableWindow(c_UseWidth.GetCheck() == BST_CHECKED);
     c_SpinWidth.EnableWindow(c_UseWidth.GetCheck() == BST_CHECKED);
        

     // initialize the special numbers
     NaNPlus.n  = 0x7FF0000000000001;
     NaNMinus.n = 0xFFF0000000000001;
     InfPlus.n  = 0x7FF0000000000000;
     InfMinus.n = 0xFFF0000000000000;
     // Show the various numbers

     if(GetFocus() != &c_Number)
        ShowNumber(number, c_FormatN, c_Number);

     if(GetFocus() != &c_HexMantissa)
        { /* show hex */
         CString s;
         s.Format(_T("%013I64X"), number.n & MantissaMask);
         c_HexMantissa.SetWindowText(s);
        } /* show hex */

     if(GetFocus() != &c_Number1)
        ShowNumber(number1, c_Format1, c_Number1);
     if(GetFocus() != &c_Number2)
        ShowNumber(number2, c_Format2, c_Number2);
     if(GetFocus() != &c_Number3)
        ShowNumber(number3, c_Format3, c_Number3);
     
     if(GetFocus() != &c_BinaryExponent &&
        GetFocus() != &c_SpinBinaryExponent)
        { /* change binary exponent */
         int ex = (int)((number.n & ExponentMask) >> 52);
         CString s;
         s.Format(_T("%d"), ex);
         c_BinaryExponent.SetWindowTextNoNotify(s);
        } /* change binary exponent */

     if(GetFocus() != &c_Excess1024Exponent &&
        GetFocus() != &c_SpinExcess1024Exponent)
        { /* change excess 1024 exponent */
         int ex = (int)(((number.n & ExponentMask) >> 52) - 1024);
         CString s;
         s.Format(_T("%d"), ex);
         c_Excess1024Exponent.SetWindowTextNoNotify(s);
        } /* change excess 1024 exponent */

    } // CfpDlg::updateControls

/****************************************************************************
*                             CfpDlg::ShowNumber
* Inputs:
*       dint & num:
*       CEdit & fmt: Desired format
*       CNoNotifyEdit & target
* Result: void
*       
* Effect: 
*       Formats num according to fmt and places it in edit
****************************************************************************/

void CfpDlg::ShowNumber(dint & num, CEdit & fmt, CNoNotifyEdit & target)
    {
     CString f;
     fmt.GetWindowText(f);
     ASSERT(!f.IsEmpty());

     CString s;
     s.Format(f, num.d);
     if(c_ShowSpaces.GetCheck() == BST_CHECKED)
        s.Replace(_T(" "), _T(""));
     target.SetWindowTextNoNotify(s);
    } // CfpDlg::ShowNumber

/****************************************************************************
*                           CfpDlg::OnUpdateRequest
* Result: void
*       
* Effect: 
*       Handles controls that ony want to update
****************************************************************************/

void CfpDlg::OnUpdateRequest()
    {
     updateControls();
    } // CfpDlg::OnUpdateRequest

/****************************************************************************
*                              CfpDlg::BitsToFP
* Result: void
*       
* Effect: 
*       Takes the bits from the controls and puts them into the floating-point
*       dint 'number'
****************************************************************************/

void CfpDlg::BitsToFP()
    {
     ULONGLONG n = 0;
     for(int i = 0; i < 64; i++)
        { /* scan buttons */
         CButton * bit = (CButton*)GetDlgItem(IDC_00 + i);
         n |= (bit->GetCheck() == BST_CHECKED ? ((ULONGLONG)1) << i : 0);
        } /* scan buttons */
     number.n = n;
     ULONGLONG mantissa = n & MantissaMask;
    } // CfpDlg::BitsToFP

/****************************************************************************
*                     CfpDlg::OnBnClickedSetFormatNumberN
* Result: void
*       
* Effect: 
*       Sets the number format for the input number display
****************************************************************************/

void CfpDlg::OnBnClickedSetFormatNumberN()
    {
     CString s;
     c_Format.GetWindowText(s);
     c_FormatN.SetWindowText(s);
     updateControls();
    } // CfpDlg::OnBnClickedSetFormatNumberN

/****************************************************************************
*                        CfpDlg::OnBnClickedSetFormat1
* Result: void
*       
* Effect: 
*       Sets the format1 box
****************************************************************************/

void CfpDlg::OnBnClickedSetFormat1()
    {
     CString s;
     c_Format.GetWindowText(s);
     c_Format1.SetWindowText(s);
     updateControls();
    } // CfpDlg::OnBnClickedSetFormat1

/****************************************************************************
*                        CfpDlg::OnBnClickedSetFormat2
* Result: void
*       
* Effect: 
*       Sets the format1 box
****************************************************************************/

void CfpDlg::OnBnClickedSetFormat2()
    {
     CString s;
     c_Format.GetWindowText(s);
     c_Format2.SetWindowText(s);
     updateControls();
    } // CfpDlg::OnBnClickedSetFormat2

/****************************************************************************
*                        CfpDlg::OnBnClickedSetFormat3
* Result: void
*       
* Effect: 
*       Sets the format3 box
****************************************************************************/

void CfpDlg::OnBnClickedSetFormat3()
    {
     CString s;
     c_Format.GetWindowText(s);
     c_Format3.SetWindowText(s);
     updateControls();
    } // CfpDlg::OnBnClickedSetFormat3

/****************************************************************************
*                           CfpDlg::OnChangeNumber
* Result: void
*       
* Effect: 
*       The number has changed by user interaction; update the binary representation
****************************************************************************/

void CfpDlg::OnChangeNumber()
    {
     CString s;
     c_Number.GetWindowText(s);
     s.Replace(_T(""), _T(" "));  // in case '' button is selected
     double d = _tstof(s);
     number.d = d;
     FPToBits();
     updateControls();
    } // CfpDlg::OnChangeNumber

/****************************************************************************
*                              CfpDlg::FPToBits
* Result: void
*       
* Effect: 
*       Converts the floating point 'number' to bits
****************************************************************************/

void CfpDlg::FPToBits()
    {
     for(int i = 0; i < 64; i++)
        { /* scan buttons */
         CButton * bit = (CButton*)GetDlgItem(IDC_00 + i);
         bit->SetCheck( number.n & ((ULONGLONG)1) << i ? BST_CHECKED : BST_UNCHECKED);
        } /* scan buttons */
    } // CfpDlg::FPToBits

/****************************************************************************
*                         CfpDlg::OnBnClickedNaNPlus
* Result: void
*       
* Effect: 
*       Sets +NaN
****************************************************************************/

void CfpDlg::OnBnClickedNaNPlus()
    {
     number = NaNPlus;
     FPToBits();
     updateControls();
    } // CfpDlg::OnBnClickedNaNPlus

/****************************************************************************
*                         CfpDlg::OnBnClickedNaNMinus
* Result: void
*       
* Effect: 
*       sets -NaN as the number
****************************************************************************/

void CfpDlg::OnBnClickedNaNMinus()
    {
     number = NaNMinus;
     FPToBits();
     updateControls();
    } // CfpDlg::OnBnClickedNaNMinus

/****************************************************************************
*                         CfpDlg::OnBnClickedInfMinus
* Result: void
*       
* Effect: 
*       Sets -Inf to number
****************************************************************************/

void CfpDlg::OnBnClickedInfMinus()
    {
     number = InfMinus;
     FPToBits();
     updateControls();
    } // CfpDlg::OnBnClickedInfMinus

/****************************************************************************
*                         CfpDlg::OnBnClickedInfPlus
* Result: void
*       
* Effect: 
*       Sets +Inf to number
****************************************************************************/

void CfpDlg::OnBnClickedInfPlus()
    {
     number = InfPlus;
     FPToBits();
     updateControls();
    } // CfpDlg::OnBnClickedInfPlus

/****************************************************************************
*                        CfpDlg::OnBnClickedShowSpaces
* Result: void
*       
* Effect: 
*       Toggles the show-space option
****************************************************************************/

void CfpDlg::OnBnClickedShowSpaces()
    {
     updateControls();
    } // CfpDlg::OnBnClickedShowSpaces

/****************************************************************************
*                           CfpDlg::OnBnClicked1To2
* Result: void
*       
* Effect: 
*       1 => 2
****************************************************************************/

void CfpDlg::OnBnClicked1To2()
    {
     number2 = number1;
     updateControls();
    } // CfpDlg::OnBnClicked1To2

/****************************************************************************
*                           CfpDlg::OnBnClicked1To3
* Result: void
*       
* Effect: 
*       number3 = number1
****************************************************************************/

void CfpDlg::OnBnClicked1To3()
    {
     number3 = number1;
     updateControls();
    } // CfpDlg::OnBnClicked1To3

/****************************************************************************
*                           CfpDlg::OnBnClicked2To1
* Result: void
*       
* Effect: 
*       number1 = number2
****************************************************************************/

void CfpDlg::OnBnClicked2To1()
    {
     number1 = number2;
     updateControls();
    } // CfpDlg::OnBnClicked2To1

/****************************************************************************
*                          CfpDlg::OnBnClicked2To3
* Result: void
*       
* Effect: 
*       number3 = number2
****************************************************************************/

void CfpDlg::OnBnClicked2To3()
    {
     number3 = number2;
     updateControls();
    } // CfpDlg::OnBnClicked2To3

/****************************************************************************
*                           CfpDlg::OnBnClicked3To1
* Result: void
*       
* Effect: 
*       number1 = number3
****************************************************************************/

void CfpDlg::OnBnClicked3To1()
    {
     number1 = number3;
     updateControls();
    } // CfpDlg::OnBnClicked3To1

/****************************************************************************
*                           CfpDlg::OnBnClicked3To2
* Result: void
*       
* Effect: 
*       number2 = number3
****************************************************************************/

void CfpDlg::OnBnClicked3To2()
    {
     number2 = number3;
     updateControls();
    } // CfpDlg::OnBnClicked3To2

/****************************************************************************
*                        CfpDlg::OnBnClickedNumberTo1
* Result: void
*       
* Effect: 
*       number1 = number
****************************************************************************/

void CfpDlg::OnBnClickedNumberTo1()
    {
     number1 = number;
     updateControls();
    } // CfpDlg::OnBnClickedNumberTo1

/****************************************************************************
*                        CfpDlg::OnBnClickedNumberTo2
* Result: void
*       
* Effect: 
*       number2 = number
****************************************************************************/

void CfpDlg::OnBnClickedNumberTo2()
    {
     number2 = number;
     updateControls();
    } // CfpDlg::OnBnClickedNumberTo2

/****************************************************************************
*                        CfpDlg::OnBnClickedNumberTo3
* Result: void
*       
* Effect: 
*       number3 = number
****************************************************************************/

void CfpDlg::OnBnClickedNumberTo3()
    {
     number3 = number;
     updateControls();
    } // CfpDlg::OnBnClickedNumberTo3

/****************************************************************************
*                           CfpDlg::OnBnClickedAdd
* Result: void
*       
* Effect: 
*       number3 = number1 + number2
****************************************************************************/

void CfpDlg::OnBnClickedAdd()
    {
     number3.d = number1.d + number2.d;
     updateControls();
    } // CfpDlg::OnBnClickedAdd

/****************************************************************************
*                         CfpDlg::OnBnClickedSubtract
* Result: void
*       
* Effect: 
*       number3 = number1 - number2
****************************************************************************/

void CfpDlg::OnBnClickedSubtract()
    {
     number3.d = number1.d - number2.d;
     updateControls();
    } // CfpDlg::OnBnClickedSubtract

/****************************************************************************
*                         CfpDlg::OnBnClickedMultiply
* Result: void
*       
* Effect: 
*       number3 = number1 * number2
****************************************************************************/

void CfpDlg::OnBnClickedMultiply()
    {
     number3.d = number1.d * number2.d;
     updateControls();
    } // CfpDlg::OnBnClickedMultiply

/****************************************************************************
*                          CfpDlg::OnBnClickedDivide
* Result: void
*       
* Effect: 
*       number3 = number1 / number2
****************************************************************************/

void CfpDlg::OnBnClickedDivide()
    {
     number3.d = number1.d / number2.d;
     updateControls();
    } // CfpDlg::OnBnClickedDivide

/****************************************************************************
*                          CfpDlg::OnChangeHexMantissa
* Result: void
*       
* Effect: 
*       Handles a change in the hex mantissa value
****************************************************************************/

void CfpDlg::OnChangeHexMantissa()
    {
     CString s;
     c_HexMantissa.GetWindowText(s);
     ULONGLONG mantissa = _tcstoui64(s, NULL, 16);
     number.n = (number.n & (SignMask | ExponentMask)) | (mantissa & MantissaMask);
     FPToBits();
     updateControls();
    } // CfpDlg::OnChangeHexMantissa

/****************************************************************************
*                          CfpDlg::OnChangeBinaryExponent
* Result: void
*       
* Effect: 
*       Handles a change in the binary exponent
****************************************************************************/

void CfpDlg::OnChangeBinaryExponent()
    {
     if(!initialized)
         return;
     DWORD n = c_SpinBinaryExponent.GetPos32();
     if(n & ~0x7FF)
        return; // illegal exponent value
     ULONGLONG ex = (ULONGLONG)n << 52;
     number.n = (number.n & ~ExponentMask) | (ex & ExponentMask);
     FPToBits();
     updateControls();
    } // CfpDlg::OnChangeBinaryExponent

/****************************************************************************
*                     CfpDlg::OnChangeExcess1024Exponent
* Result: void
*       
* Effect: 
*       
****************************************************************************/

void CfpDlg::OnChangeExcess1024Exponent()
    {
     if(!initialized)
        return;
     DWORD n = c_SpinExcess1024Exponent.GetPos32();
     ULONGLONG ex = (ULONGLONG)(n + 1024) << 52;
     number.n = (number.n & ~ExponentMask) | (ex & ExponentMask);
     FPToBits();
     updateControls();
    } // CfpDlg::OnChangeExcess1024Exponent


/****************************************************************************
*                           CfpDlg::OnChangeNumber1
* Result: void
*       
* Effect: 
*       The user has typed a value in the number 1 edit control
****************************************************************************/

void CfpDlg::OnChangeNumber1()
    {
     CString s;
     c_Number1.GetWindowText(s);
     double d = _tstof(s);
     number1.d = d;
    } // CfpDlg::OnChangeNumber1

/****************************************************************************
*                           CfpDlg::OnChangeNumber2
* Result: void
*       
* Effect: 
*       The user has typed something into number 2
****************************************************************************/

void CfpDlg::OnChangeNumber2()
    {
     CString s;
     c_Number2.GetWindowText(s);
     double d = _tstof(s);
     number2.d = d;
    } // CfpDlg::OnChangeNumber2

/****************************************************************************
*                           CfpDlg::OnChangeNumber3
* Result: void
*       
* Effect: 
*       The user typed something into number 3
****************************************************************************/

void CfpDlg::OnChangeNumber3()
    {
     CString s;
     c_Number3.GetWindowText(s);
     double d = _tstof(s);
     number3.d = d;
    } // CfpDlg::OnChangeNumber3

/****************************************************************************
*                          CfpDlg::OnBnClickedFrom1
* Result: void
*       
* Effect: 
*       number = number1
****************************************************************************/

void CfpDlg::OnBnClickedFrom1()
    {
     number = number1;
     FPToBits();
     updateControls();
    } // CfpDlg::OnBnClickedFrom1

/****************************************************************************
*                          CfpDlg::OnBnClickedFrom2
* Result: void
*       
* Effect: 
*       number = number2
****************************************************************************/

void CfpDlg::OnBnClickedFrom2()
    {
     number = number2;
     FPToBits();
     updateControls();
    } // CfpDlg::OnBnClickedFrom2

/****************************************************************************
*                          CfpDlg::OnBnClickedFrom3
* Result: void
*       
* Effect: 
*       number = number3
****************************************************************************/

void CfpDlg::OnBnClickedFrom3()
    {
     number = number3;
     FPToBits();
     updateControls();
    } // CfpDlg::OnBnClickedFrom3

/****************************************************************************
*                          CfpDlg::OnSetAllMantissa
* Result: void
*       
* Effect: 
*       Sets all the bits of the mantissa
****************************************************************************/

void CfpDlg::OnSetAllMantissa()
    {
     number.n |= MantissaMask;
     FPToBits();
     updateControls();
    } // CfpDlg::OnSetAllMantissa

/****************************************************************************
*                         CfpDlg::OnClearAllMantissa
* Result: void
*       
* Effect: 
*       Clears all the bits of the mantissa
****************************************************************************/

void CfpDlg::OnClearAllMantissa()
    {
     number.n &= ~MantissaMask;
     FPToBits();
     updateControls();
    } // CfpDlg::OnClearAllMantissa

/****************************************************************************
*                          CfpDlg::OnSetAllExponent
* Result: void
*       
* Effect: 
*       Sets all exponent bits
****************************************************************************/

void CfpDlg::OnSetAllExponent()
    {
     number.n |= ExponentMask;
     FPToBits();
     updateControls();
    } // CfpDlg::OnSetAllExponent

/****************************************************************************
*                         CfpDlg::OnClearAllExponent
* Result: void
*       
* Effect: 
*       Clears all exponent bits
****************************************************************************/

void CfpDlg::OnClearAllExponent()
    {
     number.n &= ~ExponentMask;
     FPToBits();
     updateControls();
    } // CfpDlg::OnClearAllExponent

/****************************************************************************
*                           CfpDlg::OnZeroExponent
* Result: void
*       
* Effect: 
*       Sets the exponent to 2**0
****************************************************************************/

void CfpDlg::OnZeroExponent()
    {
     c_SpinExcess1024Exponent.SetPos(0);
     updateControls();
    } // CfpDlg::OnZeroExponent
